/*
  -I started modifing for after luanch button hit - running flight time
  -Used interval to count off seconds
  -Modified for tracking simulated shuttle flight time 3/8/2021, check
   variables on LCD. Added first 4d igit 7-segment display (matrix1)
  -Added second matrix2 to track speed of flight 3/12/2021
  -Added third matrix3 to track altitude of flight 3/12/2021
  -3/13/2021 Added 5th digit - single 7segment for speed.
   Added Pot to adjust simulation time(you could speed up pretend launch)
  -Started code for buttons so can have blast off and abort.
  -Added LED to light up when a switch has to be thrown.
  -3/15/2021 - Countdown function added and is working.
  -All buttons are working on Countdown and Liftoff.
  -Big Green Blast-Off button works on bottom screws.
  -3/16/2021-started working on LED lights for maps and photo and computer
  -3/31/2021 - working on LEDs under rocket firing (launch)
  -4/11/2021 - clean code up, took out LCD stuff
*/


#include <Wire.h> 
#include <LiquidCrystal_I2C.h>
#include <Adafruit_GFX.h> 
#include "Adafruit_LEDBackpack.h" 
 
Adafruit_7segment matrix1 = Adafruit_7segment();   // Flight Time
Adafruit_7segment matrix2 = Adafruit_7segment();   // Flight Speed
Adafruit_7segment matrix3 = Adafruit_7segment();   // Flight Altitude
Adafruit_7segment matrix4 = Adafruit_7segment();   // Pre-Flight Countdown


unsigned long previousMillis = 0;        // will store last time LED was updated

int flicker = 0;                         // ===3/31/2021 Middle shuttle picture

const long interval = 974;               // interval for 1 second  (milliseconds)

long int secondcount = 0;
long int minutecount = 0;
long int hourcount = 0;
long int flightcount = 0;

long int shuttlespeed = 0;
long int altitude = 0;

int simSpeed = 1;          // Map for normal to 15 times normal simulation
int sensorReading = 0;     // Read Pot

int launchState = 0;       // Launch Button
int abortState = 0;        // Abort Button

int toponepin = 10;        // Added for mimic firing at blast-off
int botonepin = 9;         // Added for mimic firing at blast-off

int MECOpin = 5;           // See if LED concept works
int Rollpin = 4;           // See if LED concept works
int SRBpin = 3;            // See if LED concept works
int Blastpin = 2;          // See if LED concept works

int analogPin = A0;        // For Pot/simulation
int launchPin = 11;        // Launch Button
int abortPin = 8;          // Abort Button

boolean blastOff = false;  // Which button was pushed

//=============================Added for Preflight_Countdown() Function

int Payloadpin = 30;       // LEDs for pre-flight check 3/31/2021
int Fuelpin = 31;          // LEDs for pre-flight check 3/31/2021
int Crewpin = 32;          // LEDs for pre-flight check 3/31/2021
int Gimbalpin = 33;        // LEDs for pre-flight check 3/31/2021
int Heatpin = 34;          // LEDs for pre-flight check 3/31/2021
int Safetypin = 35;        // LEDs for pre-flight check 3/31/2021
int Rocketpin = 36;        // LEDs for pre-flight check 3/31/2021

int prepcount = 600;       // T-10 minutes

int prepState = 0;         // Start countdown
int stopprepState = 0;     // Stop conutdown

int prepPin = 7;           // Countdown Button
int stopprepPin = 6;       // Stop Countdown Button

boolean preFlight = false;       // Which button was pushed
boolean countComplete = false;   //10 minute countdown has completed

//======================================================================

//=========4/6/2021================Added for ShuttleOrbitPath() function

   int ledPins[] = {40, 41, 42, 43, 44, 45, 46, 47, 48};   
                         // an array of pin numbers to which LEDs are attached

   int ledPin =  -1;                            // the number of the LED pin
   int ledState = LOW;                          // ledState used to set the LED
   unsigned long previousmapMillis = 0;         // store last time LED updated
   unsigned long currentmapMillis = millis();

//======================================================================

void setup() {

  pinMode(toponepin, OUTPUT);
  pinMode(botonepin, OUTPUT);

  pinMode(MECOpin, OUTPUT);
  pinMode(Rollpin, OUTPUT);
  pinMode(SRBpin, OUTPUT);
  pinMode(Blastpin, OUTPUT);
  
  pinMode(launchPin, INPUT_PULLUP);   // Go for launch
  pinMode(abortPin, INPUT_PULLUP);    // Abort launch

//===========================================Added for Preflight Function

  pinMode(Payloadpin, OUTPUT);    // LEDs for pre-flight check 3/31/2021
  pinMode(Fuelpin, OUTPUT);       // LEDs for pre-flight check 3/31/2021
  pinMode(Crewpin, OUTPUT);       // LEDs for pre-flight check 3/31/2021
  pinMode(Gimbalpin, OUTPUT);     // LEDs for pre-flight check 3/31/2021
  pinMode(Heatpin, OUTPUT);       // LEDs for pre-flight check 3/31/2021
  pinMode(Safetypin, OUTPUT);     // LEDs for pre-flight check 3/31/2021
  pinMode(Rocketpin, OUTPUT);     // LEDs for pre-flight check 3/31/2021

  pinMode(prepPin, INPUT_PULLUP);         // Start countdown
  pinMode(stopprepPin, INPUT_PULLUP);     // Stop or Hold countdown

//======================================================================

//===========================================Added for ShuttleOrbitPath()

  for (int thisLed = 0; thisLed < 9; thisLed++) {
    pinMode(ledPins[thisLed], OUTPUT);
  }

//======================================================================

  matrix1.begin(0x70);                // Flight time
  matrix1.println(0,DEC); 
  matrix1.writeDisplay();  

  matrix2.begin(0x71);                // Flight speed
  matrix2.println(0,DEC); 
  matrix2.writeDisplay();  

  matrix3.begin(0x72);                // Flight Altitude
  matrix3.println(0,DEC); 
  matrix3.writeDisplay();  

  matrix4.begin(0x73);                // Countdown  1.2"
  matrix4.println(0,DEC); 
  matrix4.writeDisplay(); 
  
}


void loop() {

 //First check the simulation speed, 1x to 15x normal time
 //so can run Countdown and Flight at the same speed
  
 sensorReading = analogRead(analogPin);
 simSpeed = map(sensorReading, 0, 1023, 1, 15);   //Simulation Speed

  Preflight_Countdown ();
 
  // Here is where you'd put code that needs to be running all the time.
  // If the difference between current time and last time is bigger than
  // the interval (1 second) - running time after liftoff.

  launchState = digitalRead(launchPin);  
   if (launchState == LOW && countComplete == true) {
     blastOff = true;
    }
   
   
  abortState = digitalRead(abortPin);  

   if (abortState == LOW) {        // Reset everything, turn LEDs off
     
      blastOff = false;

      secondcount = 0;            // All variables back to 0
      minutecount = 0;
      hourcount = 0;
      flightcount = 0;

      shuttlespeed = 0;
      altitude = 0;

  //============================================Countdown variables
      prepcount = 600;                      // Reset countdown
      preFlight = false;       
      countComplete = false;
      matrix4.print(0);
      matrix4.writeDisplay();

      digitalWrite(Payloadpin, LOW);   
      digitalWrite(Fuelpin, LOW);      
      digitalWrite(Crewpin, LOW);      
      digitalWrite(Gimbalpin, LOW);    
      digitalWrite(Heatpin, LOW);      
      digitalWrite(Safetypin, LOW);    
      digitalWrite(Rocketpin, LOW);    
      
  //===============================================================

  //=============================================For ShuttleOrbitPath()
      // all orbit LEDs back to LOW

   for (int thisLed = 0; thisLed < 9; thisLed++) {
   
        digitalWrite(ledPins[thisLed], LOW);
     }

     ledPin = -1;

  //==================================================================
  
      matrix1.print(0);                  // All displays back to zero
      matrix1.writeDisplay();
      matrix2.print(shuttlespeed);
      matrix2.writeDisplay();
      matrix3.print(altitude);
      matrix3.writeDisplay();
     
      digitalWrite(SRBpin, LOW);         // Flight LEDs to LOW
      digitalWrite(toponepin, LOW);
      digitalWrite(botonepin, LOW);
      digitalWrite(Rollpin, LOW);
      digitalWrite(Blastpin, LOW);
      digitalWrite(MECOpin, LOW);
   }

 if (blastOff == true) {   //====All code executes within this if statement
  
    unsigned long currentMillis = millis();

    if (currentMillis - previousMillis >= interval/simSpeed) {

     flightcount = flightcount + 1;        // *****counting total seconds of flight

    // ========= top speed is 17500 MPH, full speed and altitude at 8 1/2 minutes
    // ========= altitude averages 190 - 330 miles

      shuttlespeed = map(flightcount, 0, 510, 0, 17500);   // 510 sec = 8.5 min
      if (shuttlespeed > 17500){
        shuttlespeed = random(17497, 17601);           // simulate variability
      }

      altitude = map(flightcount, 0, 510, 0, 233);   
      if (altitude > 233){
        altitude = random(230, 242);                   // simulate variability
      }
   
 //=================================================LEDs on Blast-Off pmap below
 
      if (flightcount == 1) {                  // LED on to remind to throw switch
       digitalWrite(Blastpin, HIGH);
      }
      
      if (flightcount > 1 && flightcount < 38) {      //***Blastoff photo*3/31/2021
    
               flicker = (flightcount % 2);
               if (flicker == 1){
                 digitalWrite(toponepin, HIGH);          // Under shuttle picture
                 digitalWrite(botonepin, HIGH);          // Under shuttle picture
               }
               else {
                 digitalWrite(toponepin, LOW);          // Under shuttle picture
                 digitalWrite(botonepin, LOW);          // Under shuttle picture
               }
              
       }   //===========================================Blast off photo************
       

      if (flightcount == 38) {                  // LED off after blast off
       digitalWrite(toponepin, LOW);            // under picture
       digitalWrite(botonepin, LOW);
      }

      if (flightcount == 115) {                // LED on to remind to throw switch
       digitalWrite(SRBpin, HIGH);
      }

      if (flightcount == 360) {                // LED on to remind to throw switch
       digitalWrite(Rollpin, HIGH);
      }

      if (flightcount == 510) {                // LED on to remind to throw switch
       digitalWrite(MECOpin, HIGH);
      }

      if (flightcount > 510) {                // Reach orbit in 8.5 minutes
         ShuttleOrbitPath();                  // Launch tracking orbit on world map
      }
      
 //==================================================================================
     secondcount = secondcount + 1;   
   
      if (secondcount > 59) {          // increment minutes
       secondcount = 0;
       minutecount = minutecount + 1;

       if (minutecount > 59) {         // increment hours
         minutecount = 0;
         hourcount = hourcount + 1;
         }
       }
          
     previousMillis = currentMillis;   // save the last time second passed

     matrix3.print(altitude);
     matrix3.writeDisplay();

     if (shuttlespeed < 9999) {             // only have 4-digit display!!
      matrix2.print(shuttlespeed);          // need 5 - maybe someday!
     }
     else{
     matrix2.print(shuttlespeed-9999);
     }
    
     matrix2.writeDisplay();

     matrix1.print(secondcount);
     if (minutecount <10){
       matrix1.writeDigitNum(1,minutecount);
     }
     else {
       matrix1.writeDigitNum(0,(minutecount/10));
       matrix1.writeDigitNum(1,(minutecount%10));
     }  
     
     matrix1.drawColon(true);
     matrix1.writeDisplay();  

    
  }   //====================Interval speed using milli seconds

 }   //=====================================If blastOff = true   
 
}    //===================================================Loop



//================================Preflight Function=========================

void Preflight_Countdown ()  {

  prepState = digitalRead(prepPin);  
   if (prepState == LOW) {
     preFlight = true;
   }

  stopprepState = digitalRead(stopprepPin);  
   if (stopprepState == LOW) {
      preFlight = false;
   }

 
if (preFlight == true) {          //====All code executes within this if statement

 
  unsigned long currentMillis = millis();

    if (currentMillis - previousMillis >= interval/simSpeed) {

     if (prepcount > 0) {
         prepcount = prepcount - 1;           // counting down by seconds
      }
      else {
         prepcount = 0;
         countComplete = true;
         preFlight = false;
      }

     minutecount = (prepcount/60);
     secondcount = (prepcount % 60);          // Remainder

   //================================================Added reminder check LEDs 3/30/2021
 
       if (prepcount == 550) {                      // All pre-flight System Checks
        digitalWrite(Payloadpin, HIGH);            
       }
 
       if (prepcount == 430) {                   
        digitalWrite(Fuelpin, HIGH);            
       }
       
       if (prepcount == 325) {                   
        digitalWrite(Crewpin, HIGH);            
       }
 
       if (prepcount == 235) {                   
        digitalWrite(Gimbalpin, HIGH);            
       }

       if (prepcount == 130) {                   
        digitalWrite(Heatpin, HIGH);            
       }
       
       if (prepcount == 70) {                   
        digitalWrite(Safetypin, HIGH);            
       }
 
       if (prepcount == 35) {                   
        digitalWrite(Rocketpin, HIGH);            
       }

   //====================================================================Added 3/30/2021
   
     previousMillis = currentMillis;   // save the last time second passed

     //==took minutes out 4/1/2021

     matrix4.print(prepcount);
     matrix4.writeDisplay();  

    }
    
  }  //=============================================If preFlight = true   

 }   //=============================================End of Function


//==========================Preflight Function above====================


void ShuttleOrbitPath () {


 currentmapMillis = millis();

  // 600 seconds = 10 minute x 9 LEDSs equals 90 minutes orbit for shuttle

  // digitalWrite(ledPins[0], HIGH);       // start first LED on off Atlantic
   
  if (currentmapMillis - previousmapMillis >= 600000/simSpeed) {
   
    ledPin = ledPin + 1;
    
      if (ledPin == 9) {                   // completed an orbit
         ledPin = 0;
      }
   
     previousmapMillis = currentmapMillis;   // save the last time you blinked the LED

   for (int thisLed = 0; thisLed < 9; thisLed++) {
   
     if (thisLed == ledPin) {

      digitalWrite(ledPins[thisLed], HIGH);      // one tracking station HIGH

     }

     else {

      digitalWrite(ledPins[thisLed], LOW);      // all others LOW

     }

    }
    
  }

}   //=====================================================================================
